Summary:       Light-weight cryptographic and SSL/TLS library
Name:          mbedtls
Version:       2.28.5
Release:       1%{?dist}
License:       Apache-2.0
URL:           https://www.trustedfirmware.org/projects/mbed-tls
Source0:       https://github.com/Mbed-TLS/%{name}/archive/refs/tags/v%{version}.tar.gz

BuildRequires: gcc-c++ make cmake doxygen
BuildRequires: graphviz perl-interpreter python3


%description
Mbed TLS is a C library that implements cryptographic primitives, X.509 certificate
manipulation and the SSL/TLS and DTLS protocols. Its small code footprint makes it
suitable for embedded systems.

Mbed TLS includes a reference implementation of the PSA Cryptography API.
This is currently a preview for evaluation purposes only.


%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}

%description    devel
The package contains libraries and header files and documents for developing with %{name}.


%prep
%autosetup

sed -i 's|//\(#define MBEDTLS_HAVEGE_C\)|\1|' include/mbedtls/config.h
sed -i 's|//\(#define MBEDTLS_THREADING_C\)|\1|' include/mbedtls/config.h
sed -i 's|//\(#define MBEDTLS_THREADING_PTHREAD\)|\1|' include/mbedtls/config.h


%build
export CFLAGS="%{optflags} -Wno-stringop-overflow -Wno-maybe-uninitialized"
export CXXLAGS="%{optflags} -Wno-stringop-overflow -Wno-maybe-uninitialized"


%cmake \
	-DCMAKE_BUILD_TYPE=Release \
	-DLINK_WITH_PTHREAD=ON \
	-DINSTALL_MBEDTLS_HEADERS=ON \
	-DENABLE_PROGRAMS=OFF \
	-DUSE_SHARED_MBEDTLS_LIBRARY=ON \
	-DUSE_STATIC_MBEDTLS_LIBRARY=OFF \
	-DGEN_FILES=OFF

%cmake_build
make apidoc


%install
%cmake_install
chmod 755 %{buildroot}%{_libdir}/*.so.*


%check
%ctest --output-on-failure --force-new-ctest-process --parallel 1


%files
%license LICENSE
%doc ChangeLog
%{_libdir}/*.so.*


%files devel
%{_libdir}/*.so
%{_includedir}/mbedtls/
%{_includedir}/psa/
%doc apidoc/*


%changelog
* Thu Feb 1 2024 Shuo Wang <abushwang@tencent.com> - 2.28.5-1
- fix x509parse-suite test faill
- update to 2.28.5

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.28.4-2
- Rebuilt for OpenCloudOS Stream 23.09

* Mon Aug 14 2023 Shuo Wang <abushwang@tencent.com> - 2.28.4-1
- update to 2.28.4

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.28.3-2
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Apr 21 2023 rockerzhu <rockerzhu@tencent.com> - 2.28.3-1
- Initial build.
